--
-- Script Pagliari
--
-- By HmcrE
--
-- Date: 21/03/10
--

Krone_Tridem_820 = {};

function Krone_Tridem_820.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function Krone_Tridem_820:load(xmlFile)
	
	---RetroTridem---
	self.trailingTruckBackAngle = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailingTruck#backAngle"), 20); -- Angolo di rotazione per l'asse posteriore;
	self.trailingTruckFrontAngle = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailingTruck#frontAngle"), 10); -- Angolo di rotazione per l'asse anteriore;
	self.trailingTruckActive = true;
	
	---Support---
	local supportRotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.supportRot#index"));
    if supportRotNode ~= nil then
        self.supportRot = {};
        self.supportRot.node = supportRotNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.supportRot#minRot"));
        self.supportRot.minRot = {};
        self.supportRot.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.supportRot.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.supportRot.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.supportRot#maxRot"));
        self.supportRot.maxRot = {};
        self.supportRot.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.supportRot.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.supportRot.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.supportRot.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.supportRot#rotTime"), 2)*1000;
    end;
	
	local supportTransNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.supportTrans#index"));
    if supportTransNode ~= nil then
        self.supportTrans = {};
        self.supportTrans.node = supportTransNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.supportTrans#minTrans"));
        self.supportTrans.minRot = {};
        self.supportTrans.minRot[1] = x;
        self.supportTrans.minRot[2] = y;
        self.supportTrans.minRot[3] = z;

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.supportTrans#maxTrans"));
        self.supportTrans.maxRot = {};
        self.supportTrans.maxRot[1] = x;
        self.supportTrans.maxRot[2] = y;
        self.supportTrans.maxRot[3] = z;

        self.supportTrans.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.supportTrans#transTime"), 2)*1000;
    end;
	
	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.supportHydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.supportHydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].punchPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchPoint"));	
		self.hydraulics[i].punchPoint2 = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchPoint2"));
		local ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].punchPoint);		
		self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
	end;

	self.supportActive = true;
	
	---Rotazione componenti---
	self.keyType = InputBinding.getButtonKeyName;
	self.keyName = "Taste";
	self.connectCollisions = SpecializationUtil.callSpecializationsFunction("connectCollisions");
	self.anim = SpecializationUtil.callSpecializationsFunction("anim");
	self.Go = {}; 
	self.Done = {};
	self.charId = {};
	self.clipIndex = {};
	self.CheckDone = {};
	self.moveColli = {}; 
    self.animParts = {};
	self.collisionArm = {};
	self.startpoint = {};
	self.loopCheck = {};
	self.Speed = {};
	local count = getXMLInt(xmlFile, "vehicle.animParts#count");
	local part = self.animParts;
    for i=1, count do
		part[i] = {};
        local partname = string.format("vehicle.animParts.part".."%d", i);
	    local nameR = getXMLString(xmlFile, partname.."#name");
		self.charId[nameR] = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#rootNode"));
		self.clipIndex[nameR] = getXMLString(xmlFile, partname.."#animationClip");
		self.CheckDone[nameR] = false;
		self.moveColli[nameR] = getXMLString(xmlFile, partname.."#moveColli");
		self.startpoint[nameR] = Utils.getNoNil(getXMLFloat(xmlFile, partname.."#startpoint"),0.0);
		if self.moveColli[nameR] ~= nil then
			local Collision = {};
			Collision.collision = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#collision"));
			Collision.collisionAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#collsionAttacher"));
			Collision.armAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.. "#armAttacher"));
			Collision.index = 0;
			self.collisionArm[nameR] = Collision;
			self:connectCollisions(nameR);
		end; 
		local charId = getAnimCharacterSet(self.charId[nameR]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[nameR]);
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackTime(charId, 0, self.startpoint[nameR]);
		enableAnimTrack(charId, 0);
		disableAnimTrack(charId, 0);
		self.loopCheck[nameR] = false;
		self.Speed[nameR] = 1.0;
	end;

end;

function Krone_Tridem_820:update(dt)

	---RetroTridem---
	local angle = 0;
	local frontAngle = 0;
	local backAngle = 0;	
	
	if self.trailingTruckActive and self.attacherVehicle ~= nil then
		local x1,y1,z1 = localDirectionToWorld(self.attacherVehicle.rootNode, 0, 0, 1);
		local x2,y2,z2 = localDirectionToWorld(self.rootNode, 0, 0, 1);
		local dot = x1*x2 + z1*z2;
		dot = dot / (Utils.vector2Length(x1,z1) * Utils.vector2Length(x2,z2));
		angle = math.acos(dot);		
		local cy = z1 * x2 - x1 * z2;		
		if cy < 0 then
			angle = -angle;
		end;		
		frontAngle = (self.trailingTruckFrontAngle * (angle / 50)) * -1;
		backAngle  = self.trailingTruckBackAngle * (angle / 50);				
	end;			
	
	for i=1, table.getn(self.wheels) do
		local x,y,z = getRotation(self.wheels[i].repr);			
		local newX, newY, newZ = getWheelShapePosition(self.wheels[i].node, self.wheels[i].wheelShape);
		setTranslation(self.wheels[i].repr, newX, newY, newZ);
		local axleSpeed = getWheelShapeAxleSpeed(self.wheels[i].node, self.wheels[i].wheelShape)*3.14159/180;
		x = x+axleSpeed*dt/1000.0;
		if i == 5 or i == 6 then -- Index delle ruote sull'asse anteriore;
			setWheelShapeProps(self.wheels[i].node, self.wheels[i].wheelShape, 0, 0, frontAngle);
			setRotation(self.wheels[i].repr, x, frontAngle, z);
		elseif i == 1 or i == 2 then -- Index delle ruote sull'asse posteriore;
			setWheelShapeProps(self.wheels[i].node, self.wheels[i].wheelShape, 0, 0, backAngle);
			setRotation(self.wheels[i].repr, x, backAngle, z);					
		else
			steeringAngle = 0;
			setRotation(self.wheels[i].repr, x, steeringAngle, z);
		end;
	end;
	
	---Support---
	if self.supportRot ~= nil then
		local x, y, z = getRotation(self.supportRot.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.supportRot.maxRot, self.supportRot.minRot, 3, self.supportRot.rotTime, dt, self.supportActive);
		setRotation(self.supportRot.node, unpack(newRot));
	end;
	
	if self.supportTrans ~= nil then
		local x, y, z = getTranslation(self.supportTrans.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.supportTrans.maxRot, self.supportTrans.minRot, 3, self.supportTrans.rotTime, dt, self.supportActive);
		setTranslation(self.supportTrans.node, unpack(newTrans));
	end;

	for i=1, table.getn(self.hydraulics) do
		local ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		local bx, by, bz = getWorldTranslation(self.hydraulics[i].punchPoint2);
		local x, y, z = worldDirectionToLocal(getParent(self.hydraulics[i].node), bx-ax, by-ay, bz-az);		
		setDirection(self.hydraulics[i].node, x, y, z, 0, 1, 0);		
		if self.hydraulics[i].punch ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.hydraulics[i].punch, 0, 0, distance-self.hydraulics[i].punchDistance);
		end;
	end;
	
	for i, jointDesc in pairs(self.componentJoints) do
	   setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
	end;

	---Rotazione componenti---
	if self.attacherVehicle then
	
		if self:getIsActiveForInput() and InputBinding.isPressed(InputBinding.Cassone0) then
				self.Go.Cassone = true; 
				self.Done.Cassone = true;
		elseif self:getIsActiveForInput() and InputBinding.isPressed(InputBinding.Cassone1) then
				self.Go.Cassone = false; 
				self.Done.Cassone = true;
			else
				self.Done.Cassone = false; 
		end;
		
		if self:getIsActiveForInput() and InputBinding.isPressed(InputBinding.Sponda_Anteriore0) then
				self.Go.Sponda_Anteriore = true; 
				self.Done.Sponda_Anteriore = true;
		elseif self:getIsActiveForInput() and InputBinding.isPressed(InputBinding.Sponda_Anteriore1) then
				self.Go.Sponda_Anteriore = false; 
				self.Done.Sponda_Anteriore = true;
			else
				self.Done.Sponda_Anteriore = false; 
		end;
		
	end;
	
	self:anim("Cassone", false);
	self:anim("Sponda_Anteriore", false);
	
end;

function Krone_Tridem_820:delete()
end;

function Krone_Tridem_820:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Krone_Tridem_820:keyEvent(unicode, sym, modifier, isDown)
	
	if self.attacherVehicle ~= nil then
		if isDown and sym == Input.KEY_z then
			self.trailingTruckActive = not self.trailingTruckActive;
		end;
	end;

end;

function Krone_Tridem_820:draw()

	g_currentMission:addExtraPrintText("Tasto J/N: Inclina Cassone");
	g_currentMission:addExtraPrintText("Tasto K/M: Inclina Sponda anteriore");
		
	if self.attacherVehicle ~= nil then
		if self.trailingTruckActive then	
			g_currentMission:addExtraPrintText("Tasto Z: Blocca asse posteriore");
		else
			g_currentMission:addExtraPrintText("Tasto Z: Sblocca asse posteriore");
		end;
	end;
	
end;

function Krone_Tridem_820:anim(varName, loopCheck)
	if self.moveColli[varName] ~= nil then
		local Collision = self.collisionArm[varName];
		setJointFrame(Collision.index, 0, Collision.armAttacher);
	end;
	local loopCheck = self.loopCheck[varName];
	local speed = Utils.getNoNil(self.Speed[varName],1);
	local offset = 10;  
	local charId = getAnimCharacterSet(self.charId[varName]);
	local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
	if self.Done[varName] ~= false then
		if self.Go[varName] == true then
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, loopCheck);
			setAnimTrackSpeedScale(charId, 0, speed);
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck == false then
				self.Done[varName] = false;	
				self.CheckDone[varName] = self.Go[varName];	
			end;
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck then
				local setTime = getAnimClipDuration(charId, clipIndex) - getAnimClipDuration(charId, clipIndex);
				setAnimTrackTime(charId, 0, setTime);
			end;
		elseif self.Go[varName] == false then
			if loopCheck == true then
				self.Done[varName] = false;	
			else
				assignAnimTrackClip(charId , 0, clipIndex);
				setAnimTrackLoopState(charId, 0, loopCheck);
				setAnimTrackSpeedScale(charId, 0, -speed);
				enableAnimTrack(charId, 0);
				if getAnimTrackTime(charId, 0) <= 0 then
					self.Done[varName] = false;	
					self.CheckDone[varName] = self.Go[varName];
				end;
			end;
		elseif self.Go[varName] ~= nil then
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, loopCheck);
			if self.Go[varName] < 0.0 then
				self.Go[varName] = 0.0;
			elseif self.Go[varName] > getAnimClipDuration(charId, clipIndex) then
				self.Go[varName] = getAnimClipDuration(charId, clipIndex);
			end;
			if getAnimTrackTime(charId, 0) >= self.Go[varName] then
				setAnimTrackSpeedScale(charId, 0, -speed);
			else
				setAnimTrackSpeedScale(charId, 0, speed);
			end;
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) <= self.Go[varName] + offset and getAnimTrackTime(charId, 0) >= self.Go[varName] - offset then
				self.Done[varName] = false;	
				self.CheckDone[varName] = self.Go[varName];
			end;
		end;
	end;
	if self.Done[varName] == false then
		disableAnimTrack(charId, 0);
	end;
end;

function Krone_Tridem_820:onDetach()
	self.supportActive = true;
end;

function Krone_Tridem_820:onAttach()
	self.supportActive = false;
end;